package com.caimei.service.auth.impl;

import com.caimei.mapper.cmMapper.AuthTemplateMapper;
import com.caimei.model.ResponseJson;
import com.caimei.model.vo.*;
import com.caimei.service.auth.AuthTemplateService;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * Description
 *
 * @author : Aslee
 * @date : 2022/7/6
 */
@Slf4j
@Service
public class AuthTemplateServiceImpl implements AuthTemplateService {

    @Resource
    private AuthTemplateMapper authTemplateMapper;

    @Override
    public ResponseJson<PageInfo<TemplateListVo>> getTemplateList(Integer listType, Integer authUserId, Integer pageNum, Integer pageSize) {
        if (null == listType) {
            return ResponseJson.error("列表类型不能为空", null);
        }
        if (2 == listType && null == authUserId) {
            return ResponseJson.error("供应商用户id不能为空", null);
        }
        PageHelper.startPage(pageNum, pageSize);
        List<TemplateListVo> templateList = authTemplateMapper.getTemplateList(listType, authUserId);
        PageInfo<TemplateListVo> pageInfo = new PageInfo<>(templateList);
        return ResponseJson.success(pageInfo);
    }

    @Override
    public ResponseJson saveTemplate(Integer templateId, String templateImage, Integer authUserId, Integer status, String qrPosition) {
        boolean insertFlag = null == templateId;
        if (insertFlag) {
            authTemplateMapper.insertTemplate(templateImage, authUserId);
        } else {
            authTemplateMapper.updateSelective(templateId, templateImage, authUserId, status, qrPosition);
        }
        return ResponseJson.success();
    }
}
